<?php
/*
Plugin Name: Ranges - Video Player With Multiple Start and End Points
Description: This plugin will allow you to insert an advanced HTML5 Video Player With a Playlist of intervals
Version: 1.0
Author: Lambert Group
Author URI: https://1.envato.market/OZ5Zr
Text Domain: vp3-html5
*/

$lbg_vp3_html5_path = trailingslashit(dirname(__FILE__));  //empty

//all the messages
$lbg_vp3_html5_messages = array(
		'version' => esc_html('<div class="error">Ranges - Video Player With Multiple Start and End Points plugin requires WordPress 3.0 or newer. <a href="https://codex.wordpress.org/Upgrading_WordPress">Please update!</a></div>', 'vp3-html5' ),
		'data_saved' => esc_html('Data Saved!', 'vp3-html5' ),
		'empty_name' => esc_html('Name - required', 'vp3-html5' ),
		'empty_mp4' => esc_html('MP4 - required', 'vp3-html5' ),
		'empty_webm' => esc_html('WEBM - required', 'vp3-html5' ),
		'empty_categ' => esc_html('Category - required', 'vp3-html5' ),
		'invalid_request' => esc_html('Invalid Request!', 'vp3-html5' ),
		'generate_for_this_player' => esc_html('You can start customizing this player.', 'vp3-html5' ),
		'duplicate_complete' => esc_html('Duplication process is complete!', 'vp3-html5' )
	);


global $wp_version;

if ( !version_compare($wp_version,"3.0",">=")) {
	wp_die (esc_html($lbg_vp3_html5_messages['version'], 'vp3-html5' ));
}




function lbg_vp3_html5_activate() {
	//db creation, create admin options etc.
	global $wpdb;

	$lbg_vp3_html5_collate = ' COLLATE utf8_general_ci';

	$sql0 = "CREATE TABLE `" . $wpdb->prefix . "lbg_vp3_html5_players` (
			`id` INT UNSIGNED NOT NULL AUTO_INCREMENT ,
			`name` VARCHAR( 255 ) NOT NULL ,
			PRIMARY KEY ( `id` )
			) ENGINE=MyISAM  DEFAULT CHARSET=utf8";

	$sql1 = "CREATE TABLE `" . $wpdb->prefix . "lbg_vp3_html5_settings` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
	`youtubeVideoID` varchar(255) NOT NULL DEFAULT '',
	`vimeoVideoID` varchar(255) NOT NULL DEFAULT '',
	`mp4Url` text NOT NULL DEFAULT '',
	`mp4PreviewUrl` text NOT NULL DEFAULT '',
	`controlsColor` varchar(20) NOT NULL DEFAULT 'd0d0d0',
	`controlsColorHover` varchar(20) NOT NULL DEFAULT 'FFF000',
  `width` smallint(5) unsigned NOT NULL DEFAULT '980',
  `height` smallint(5) unsigned NOT NULL DEFAULT '399',
  `responsive` varchar(8) NOT NULL DEFAULT 'true',
  `responsiveRelativeToBrowser` varchar(8) NOT NULL DEFAULT 'false',
	`centerPlayer` varchar(8) NOT NULL DEFAULT 'true',
  `skin` varchar(255) NOT NULL DEFAULT 'default',
  `initialVolume` float unsigned NOT NULL DEFAULT '1',
  `autoPlayFirstVideo` varchar(8) NOT NULL DEFAULT 'true',
	`autoPlayOnMobile` varchar(8) NOT NULL DEFAULT 'false',
  `loop` varchar(8) NOT NULL DEFAULT 'true',
  `shuffle` varchar(8) NOT NULL DEFAULT 'false',
  `firstVideo` smallint(5) unsigned NOT NULL DEFAULT '0',
  `showTopTitle` varchar(8) NOT NULL DEFAULT 'true',
  `showTimer` varchar(8) NOT NULL DEFAULT 'true',
  `showRewindBut` varchar(8) NOT NULL DEFAULT 'true',
  `showPlayBut` varchar(8) NOT NULL DEFAULT 'true',
  `showVolumeBut` varchar(8) NOT NULL DEFAULT 'true',
  `showDownloadBut` varchar(8) NOT NULL DEFAULT 'true',
  `showTwitterBut` varchar(8) NOT NULL DEFAULT 'true',
  `showInfoBut` varchar(8) NOT NULL DEFAULT 'true',
  `showFacebookBut` varchar(8) NOT NULL DEFAULT 'true',
  `facebookAppID` varchar(255) NOT NULL DEFAULT '',
  `facebookShareTitle` varchar(255) NOT NULL DEFAULT 'LBG VP3 HTML5 Video Player',
  `facebookShareDescription` varchar(255) NOT NULL DEFAULT 'A top-notch responsive HTML5 Video Player compatible with all major browsers and mobile devices.',
  `showPlaylistBut` varchar(8) NOT NULL DEFAULT 'true',
  `showFullscreenBut` varchar(8) NOT NULL DEFAULT 'true',
  `showShuffleBut` varchar(8) NOT NULL DEFAULT 'true',
  `showNextPrevBut` varchar(8) NOT NULL DEFAULT 'true',
  `borderWidth` smallint(5) unsigned NOT NULL DEFAULT '20',
  `borderColor` varchar(20) NOT NULL DEFAULT '4a4a4a',
  `playlistWidth` smallint(5) unsigned NOT NULL DEFAULT '282',
  `suggestedQuality` varchar(255) NOT NULL DEFAULT 'default',
  `controlsBgFullScreenColor` varchar(20) NOT NULL DEFAULT '000000',
  `playlistScrollerBgColorOFF` varchar(20) NOT NULL DEFAULT 'CCCCCC',
  `playlistScrollerBgColorON` varchar(20) NOT NULL DEFAULT 'FFFFFF',
  `numberOfThumbsPerScreen` smallint(5) unsigned NOT NULL DEFAULT '0',
  `showLogo` varchar(8) NOT NULL DEFAULT 'true',
  `logoImagePath` text NOT NULL DEFAULT '',
  `logoLink` varchar(255) NOT NULL DEFAULT 'https://codecanyon.net/user/LambertGroup?ref=LambertGroup',
  `logoTarget` varchar(10) NOT NULL DEFAULT '_blank',
  `playlistRecordShowImg` varchar(8) NOT NULL DEFAULT 'true',
  `playlistRecordShowTitle` varchar(8) NOT NULL DEFAULT 'true',
  `playlistRecordShowDesc` varchar(8) NOT NULL DEFAULT 'true',
  `playlistRecordHeight` smallint(5) unsigned NOT NULL DEFAULT '89',
  `playlistRecordPadding` smallint(5) unsigned NOT NULL DEFAULT '10',
  `playlistTitleFontSize` smallint(5) unsigned NOT NULL DEFAULT '15',
  `playlistTitleLineHeight` smallint(5) unsigned NOT NULL DEFAULT '15',
  `playlistDescFontSize` smallint(5) unsigned NOT NULL DEFAULT '12',
  `playlistDescLineHeight` smallint(5) unsigned NOT NULL DEFAULT '15',
  `playlistRecordBgOffColor` varchar(255) NOT NULL DEFAULT 'eeeeee',
  `playlistRecordTitleOffColor` varchar(20) NOT NULL DEFAULT '333333',
  `playlistRecordDescOffColor` varchar(20) NOT NULL DEFAULT '333333',
  `playlistRecordBgOffImgOpacity` smallint(5) unsigned NOT NULL DEFAULT '100',
  `playlistRecordBgOnColor` varchar(255) NOT NULL DEFAULT 'de1a21',
  `playlistRecordTitleOnColor` varchar(20) NOT NULL DEFAULT 'FFFFFF',
  `playlistRecordDescOnColor` varchar(20) NOT NULL DEFAULT 'FFFFFF',
  `playlistRecordBgOnImgOpacity` smallint(5) unsigned NOT NULL DEFAULT '100',
  `playlistBgColor` varchar(20) NOT NULL DEFAULT '4a4a4a',
  `playlistRecordTitleLimit` smallint(5) unsigned NOT NULL DEFAULT '22',
  `playlistRecordDescLimit` smallint(5) unsigned NOT NULL DEFAULT '84',
  `showPlaylistOnInit` varchar(8) NOT NULL DEFAULT 'true',
  `categoryRecordBgOffColor` varchar(20) NOT NULL DEFAULT '000000',
  `categoryRecordBgOnColor` varchar(20) NOT NULL DEFAULT '252525',
  `categoryRecordBottomBorderOffColor` varchar(20) NOT NULL DEFAULT '333333',
  `categoryRecordBottomBorderOnColor` varchar(20) NOT NULL DEFAULT '333333',
  `categoryRecordTextOffColor` varchar(20) NOT NULL DEFAULT '4c4c4c',
  `categoryRecordTextOnColor` varchar(20) NOT NULL DEFAULT 'de1a21',
  `showCategs` varchar(8) NOT NULL DEFAULT 'false',
  `firstCateg` varchar(255) NOT NULL DEFAULT '',
  `selectedCategBg` varchar(20) NOT NULL DEFAULT 'transparent',
  `selectedCategOffColor` varchar(20) NOT NULL DEFAULT 'FFFFFF',
  `selectedCategOnColor` varchar(20) NOT NULL DEFAULT 'de1a28',
  `showSearch` varchar(8) NOT NULL DEFAULT 'true',
  `searchAreaBg` varchar(20) NOT NULL DEFAULT 'transparent',
  `searchInputText` varchar(255) NOT NULL DEFAULT 'search...',
  `searchInputBg` varchar(20) NOT NULL DEFAULT 'cccccc',
  `searchInputBorderColor` varchar(20) NOT NULL DEFAULT '4a4a4a',
  `searchInputTextColor` varchar(20) NOT NULL DEFAULT '333333',
  `topTitleColor` varchar(20) NOT NULL DEFAULT 'FFFFFF',
  `timerColor` varchar(20) NOT NULL DEFAULT 'FFFFFF',
  `bufferEmptyColor` varchar(20) NOT NULL DEFAULT '929292',
  `bufferFullColor` varchar(20) NOT NULL DEFAULT '333333',
  `seekbarColor` varchar(20) NOT NULL DEFAULT 'FFFFFF',
  `volumeOffColor` varchar(20) NOT NULL DEFAULT '454545',
  `volumeOnColor` varchar(20) NOT NULL DEFAULT 'FFFFFF',
  `playButColorOff` varchar(20) NOT NULL DEFAULT 'de1a21',
  `playButColorOn` varchar(20) NOT NULL DEFAULT 'de1a21',
  `googleTrakingOn` varchar(8) NOT NULL DEFAULT 'false',
  `googleTrakingCode` varchar(255) NOT NULL DEFAULT '',
  `getYouTubeData` varchar(8) NOT NULL DEFAULT 'true',
  `origThumbImgW` smallint(5) unsigned NOT NULL DEFAULT '69',
  `origThumbImgH` smallint(5) unsigned NOT NULL DEFAULT '69',
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8";

	$sql2 = "CREATE TABLE `". $wpdb->prefix . "lbg_vp3_html5_playlist` (
	  `id` int(10) unsigned NOT NULL auto_increment,
	  `playerid` int(10) unsigned NOT NULL,
	  `imgplaylist` text NOT NULL,
	  `category` text NOT NULL,
	  `title` text,
	  `desc` text,
		`startpoint` varchar(255) NOT NULL DEFAULT '',
		`endpoint` varchar(255) NOT NULL DEFAULT '',
	  `ord` int(10) unsigned NOT NULL,
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8";

	$sql3 = "CREATE TABLE `". $wpdb->prefix . "lbg_vp3_html5_categories` (
	  `id` int(10) unsigned NOT NULL auto_increment,
	  `categ` varchar(255) NOT NULL,
	  PRIMARY KEY  (`id`),
	  UNIQUE KEY `categ` ( `categ` )
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8";

	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($sql0.$lbg_vp3_html5_collate);
	dbDelta($sql1.$lbg_vp3_html5_collate);
	dbDelta($sql2.$lbg_vp3_html5_collate);
	dbDelta($sql3.$lbg_vp3_html5_collate);

	//initialize the players table with the first player type
	$rows_count = $wpdb->get_var( "SELECT COUNT(*) FROM ". $wpdb->prefix ."lbg_vp3_html5_players;" );
	if (!$rows_count) {
		$wpdb->insert(
			$wpdb->prefix . "lbg_vp3_html5_players",
			array(
				'name' => 'Default',
			),
			array(
				'%s'
			)
		);
	}

	// initialize the settings
	$rows_count = $wpdb->get_var( "SELECT COUNT(*) FROM ". $wpdb->prefix ."lbg_vp3_html5_settings;" );
	if (!$rows_count) {
		lbg_vp3_html5_insert_settings_record(1);
	}


	//initialize categories
	$rows_count = $wpdb->get_var( "SELECT COUNT(*) FROM ". $wpdb->prefix ."lbg_vp3_html5_categories;" );
	if (!$rows_count) {
		$wpdb->insert(
			$wpdb->prefix . "lbg_vp3_html5_categories",
			array(
				'categ' => 'ALL CATEGORIES'
			),
			array(
				'%s'
			)
		);
	}

}



function lbg_vp3_html5_insert_settings_record($player_id) {
	global $wpdb;
	$path_to_plugin = plugin_dir_url( __FILE__ );
	$wpdb->insert(
			$wpdb->prefix . "lbg_vp3_html5_settings",
			array(
				'skin' => 'default',
				'logoImagePath' => sanitize_text_field($path_to_plugin.'lbg_vp3_html5/skins/logo_watermark.png')
			),
			array(
				'%s',
				'%s'
			)
		);
}


function lbg_vp3_html5_init_sessions() {
	global $wpdb;
	if (!session_id()) {
		session_start();

		//initialize the session
		if (!isset($_SESSION['xid'])) {
			$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_vp3_html5_players) LIMIT 0, 1";
			$row = $wpdb->get_row($safe_sql,ARRAY_A);
			//$row=lbg_vp3_html5_unstrip_array($row);
    		$_SESSION['xid'] = $row['id'];
    		$_SESSION['xname'] = $row['name'];
		}
	}
}


function lbg_vp3_html5_load_styles() {
	if(strpos($_SERVER['PHP_SELF'], 'wp-admin') !== false) { //loads css in admin
		$page = (isset($_GET['page'])) ? $_GET['page'] : '';
		if(preg_match('/LBG_VP3_HTML5/i', $page)) {
			wp_enqueue_style('jquery-ui-pepper-grinder', plugins_url('css/jquery-ui.min.css', __FILE__));
			wp_enqueue_style('lbg-vp3-html5-css', plugins_url('css/styles.css', __FILE__));
			wp_enqueue_style('lbg-vp3-html5-colorpicker-css', plugins_url('css/colorpicker/colorpicker.css', __FILE__));

			wp_enqueue_style('thickbox');
		}
	} else if (!is_admin()) { //loads css in front-end
		wp_enqueue_style('lbg-vp3-html5-site-css', plugins_url('lbg_vp3_html5/lbg_vp3_html5.css', __FILE__));
		wp_register_style('pt_sans-googleFonts', plugins_url('css/pt_sans.css', __FILE__));
    wp_enqueue_style( 'pt_sans-googleFonts');
	}
}

function lbg_vp3_html5_load_scripts() {
	$page = (isset($_GET['page'])) ? $_GET['page'] : '';
	if(preg_match('/LBG_VP3_HTML5/i', $page)) {
		//loads scripts in admin
			wp_enqueue_script('jquery');
			wp_enqueue_script('jquery-ui-core');
			wp_enqueue_script('jquery-ui-widget');
			wp_enqueue_script('jquery-ui-mouse');
			wp_enqueue_script('jquery-ui-accordion');
			wp_enqueue_script('jquery-ui-autocomplete');
			wp_enqueue_script('jquery-ui-slider');
			wp_enqueue_script('jquery-ui-tabs');
			wp_enqueue_script('jquery-ui-sortable');
			wp_enqueue_script('jquery-ui-draggable');
			wp_enqueue_script('jquery-ui-droppable');
			wp_enqueue_script('jquery-ui-selectable');
			wp_enqueue_script('jquery-ui-position');
			wp_enqueue_script('jquery-ui-datepicker');
			wp_enqueue_script('jquery-ui-resizable');
			wp_enqueue_script('jquery-ui-dialog');
			wp_enqueue_script('jquery-ui-button');

			wp_register_script('lbg-admin-colorpicker', plugins_url('js/colorpicker/colorpicker.js', __FILE__));
			wp_enqueue_script('lbg-admin-colorpicker');

			wp_register_script('lbg-admin-editinplace', plugins_url('js/jquery.editinplace.js', __FILE__));
			wp_enqueue_script('lbg-admin-editinplace');

			wp_register_script('lbg-admin-toggle', plugins_url('js/myToggle.js', __FILE__));
			wp_enqueue_script('lbg-admin-toggle');

			wp_enqueue_script('media-upload'); // before w.p 3.5
			wp_enqueue_media();// from w.p 3.5
			wp_enqueue_script('thickbox');

	} else if (!is_admin()) { //loads scripts in front-end
		wp_enqueue_script('jquery');
			wp_enqueue_script('jquery-ui-core');

			wp_enqueue_script('jquery-ui-slider');
			wp_enqueue_script('jquery-ui-progressbar');
			wp_enqueue_script('jquery-effects-drop');


		wp_register_script('lbg-mousewheel', plugins_url('lbg_vp3_html5/js/jquery.mousewheel.min.js', __FILE__));
		wp_enqueue_script('lbg-mousewheel');

		wp_register_script('lbg-touchSwipe', plugins_url('lbg_vp3_html5/js/jquery.touchSwipe.min.js', __FILE__));
		wp_enqueue_script('lbg-touchSwipe');

		wp_register_script('lbg-screenfull', plugins_url('lbg_vp3_html5/js/screenfull.min.js', __FILE__));
		wp_enqueue_script('lbg-screenfull');

		wp_register_script('lbg-vimeo', plugins_url('lbg_vp3_html5/js/vimeo.player.js', __FILE__));
		wp_enqueue_script('lbg-vimeo');

		wp_register_script('lbg-26e31fe740', plugins_url('lbg_vp3_html5/js/26e31fe740.js', __FILE__));
		wp_enqueue_script('lbg-26e31fe740');

		wp_register_script('lbg-lbg_vp3_html5', plugins_url('lbg_vp3_html5/js/lbg_vp3_html5.js', __FILE__));
		wp_enqueue_script('lbg-lbg_vp3_html5');

		wp_register_script('lbg-google_a', plugins_url('lbg_vp3_html5/js/google_a.js', __FILE__));
		wp_enqueue_script('lbg-google_a');
	}

}



// adds the menu pages
function lbg_vp3_html5_plugin_menu() {
	add_menu_page('LBG VP3 HTML5 Admin Interface', 'LBG VP3 HTML5', 'edit_posts', 'LBG_VP3_HTML5', 'lbg_vp3_html5_overview_page',
	plugins_url('images/lbg_icon.png', __FILE__));
	add_submenu_page( 'LBG_VP3_HTML5', 'LBG VP3 HTML5 Overview', 'Overview', 'edit_posts', 'LBG_VP3_HTML5', 'lbg_vp3_html5_overview_page');
	add_submenu_page( 'LBG_VP3_HTML5', 'LBG VP3 HTML5 Manage Players', 'Manage Players', 'edit_posts', 'LBG_VP3_HTML5_Manage_Players', 'lbg_vp3_html5_player_manage_players_page');
	add_submenu_page( 'LBG_VP3_HTML5', 'LBG VP3 HTML5 Manage Players Add New', 'Add New', 'edit_posts', 'LBG_VP3_HTML5_Add_New', 'lbg_vp3_html5_player_manage_players_add_new_page');
	add_submenu_page( 'LBG VP3 HTML5 Manage Players', 'LBG VP3 HTML5 Player Settings', 'Player Settings', 'edit_posts', 'LBG_VP3_HTML5_Settings', 'lbg_vp3_html5_player_settings_page');
	add_submenu_page( 'LBG VP3 HTML5 Manage Players', 'LBG VP3 HTML5 Player Playlist', 'Playlist', 'edit_posts', 'LBG_VP3_HTML5_Playlist', 'lbg_vp3_html5_player_playlist_page');
	add_submenu_page( 'LBG_VP3_HTML5_Settings', 'LBG VP3 HTML5 Player Settings', 'Duplicate Player', 'edit_posts', 'LBG_VP3_HTML5_Duplicate_Player', 'lbg_vp3_html5_duplicate_player_page');
	add_submenu_page( 'LBG_VP3_HTML5', 'LBG VP3 HTML5 Help', 'Help', 'edit_posts', 'LBG_VP3_HTML5_Help', 'lbg_vp3_html5_player_help_page');
}


//HTML content for overview page
function lbg_vp3_html5_overview_page()
{
	global $lbg_vp3_html5_path;
	include_once($lbg_vp3_html5_path . 'tpl/overview.php');
}

//HTML content for Manage Players
function lbg_vp3_html5_player_manage_players_page()
{
	global $wpdb;
	global $lbg_vp3_html5_messages;
	global $lbg_vp3_html5_path;

	//delete player
	if (isset($_GET['id'])) {
		//delete from wp_lbg_vp3_html5_players
		$wpdb->query($wpdb->prepare("DELETE FROM ".$wpdb->prefix."lbg_vp3_html5_players WHERE id = %d",$_GET['id']));

		//delete from wp_lbg_vp3_html5_settings
		$wpdb->query($wpdb->prepare("DELETE FROM ".$wpdb->prefix."lbg_vp3_html5_settings WHERE id = %d",$_GET['id']));

		//delete from wp_lbg_vp3_html5_playlist
		$wpdb->query($wpdb->prepare("DELETE FROM ".$wpdb->prefix."lbg_vp3_html5_playlist WHERE playerid = %d",$_GET['id']));

		//initialize the session
		$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_vp3_html5_players) ORDER BY id";
		$row = $wpdb->get_row($safe_sql,ARRAY_A);
		$row=lbg_vp3_html5_unstrip_array($row);
		if ($row['id']) {
			$_SESSION['xid']=$row['id'];
			$_SESSION['xname']=$row['name'];
		}
	}


	$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_vp3_html5_players) ORDER BY id";
	$result = $wpdb->get_results($safe_sql,ARRAY_A);
	include_once($lbg_vp3_html5_path . 'tpl/players.php');

}

//HTML content for Manage Categories
function lbg_vp3_html5_player_manage_categories_page()
{
	global $wpdb;
	global $lbg_vp3_html5_messages;
	global $lbg_vp3_html5_path;

	//delete player
	if (isset($_GET['id'])) {
		//delete from wp_lbg_vp3_html5_categories
		$wpdb->query($wpdb->prepare("DELETE FROM ".$wpdb->prefix."lbg_vp3_html5_categories WHERE id = %d",$_GET['id']));
	}

	if (isset($_GET['categID']) && isset($_GET['origCategName'])) {
		$wpdb->update(
				$wpdb->prefix .'lbg_vp3_html5_categories',
				array(
				'categ' => sanitize_text_field($_POST['update_value'])
				),
				array( 'id' => $_GET['categID'] )
			);
	}


	$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_vp3_html5_categories) ORDER BY id";
	$result = $wpdb->get_results($safe_sql,ARRAY_A);
	include_once($lbg_vp3_html5_path . 'tpl/categories.php');

}


//HTML content for Manage Players - Add New
function lbg_vp3_html5_player_manage_players_add_new_page()
{
	global $wpdb;
	global $lbg_vp3_html5_messages;
	global $lbg_vp3_html5_path;

	if(array_key_exists('Submit', $_POST) && $_POST['Submit'] == 'Add New') {
		$errors_arr=array();
		if (empty($_POST['name']))
			$errors_arr[]=$lbg_vp3_html5_messages['empty_name'];

		if (count($errors_arr)) {
				include_once($lbg_vp3_html5_path . 'tpl/add_player.php'); ?>
				<div id="error" class="error"><p><?php echo implode("<br>", $errors_arr);?></p></div>
		  	<?php } else { // no errors
					$wpdb->insert(
						$wpdb->prefix . "lbg_vp3_html5_players",
						array(
							'name' => sanitize_text_field($_POST['name'])
						),
						array(
							'%s'
						)
					);
					//insert default player settings for this new player
					lbg_vp3_html5_insert_settings_record($wpdb->insert_id);
					?>
						<div class="wrap">
							<div id="lbg_logo">
								<h2><?php esc_html_e( 'Manage Players - Add New Player' , 'vp3-html5' );?></h2>
				 			</div>
							<div id="message" class="updated"><p><?php echo esc_html($lbg_vp3_html5_messages['data_saved']);?></p><p><?php echo esc_html($lbg_vp3_html5_messages['generate_for_this_player']);?></p></div>
							<div>
								<p>&raquo; <a href="?page=LBG_VP3_HTML5_Add_New"><?php esc_html_e( 'Add New (player)' , 'vp3-html5' );?></a></p>
								<p>&raquo; <a href="?page=LBG_VP3_HTML5_Manage_Players"><?php esc_html_e( 'Back to Manage Players' , 'vp3-html5' );?></a></p>
							</div>
						</div>
		  	<?php }
	} else {
		include_once($lbg_vp3_html5_path . 'tpl/add_player.php');
	}

}


//HTML content for Manage Categories - Add New Category
function lbg_vp3_html5_player_manage_players_add_new_category_page()
{
	global $wpdb;
	global $lbg_vp3_html5_messages;
	global $lbg_vp3_html5_path;

	if($_POST['Submit'] == 'Add New') {
		$errors_arr=array();
		if (empty($_POST['categ']))
			$errors_arr[]=$lbg_vp3_html5_messages['empty_name'];

		if (count($errors_arr)) {
				include_once($lbg_vp3_html5_path . 'tpl/add_category.php'); ?>
				<div id="error" class="error"><p><?php echo implode("<br>", $errors_arr);?></p></div>
		  	<?php } else { // no errors
					$wpdb->insert(
						$wpdb->prefix . "lbg_vp3_html5_categories",
						array(
							'categ' => sanitize_text_field($_POST['categ'])
						),
						array(
							'%s'
						)
					);
					?>
						<div class="wrap">
							<div id="lbg_logo">
								<h2>Manage Categories - Add New Category</h2>
				 			</div>
							<div id="message" class="updated"><p><?php echo esc_html($lbg_vp3_html5_messages['data_saved']);?></p></div>
							<div>
								<p>&raquo; <a href="?page=LBG_VP3_HTML5_Add_New_Category">Add New (category)</a></p>
								<p>&raquo; <a href="?page=LBG_VP3_HTML5_Manage_Categories">Back to Manage Categories</a></p>
							</div>
						</div>
		  	<?php }
	} else {
		include_once($lbg_vp3_html5_path . 'tpl/add_category.php');
	}

}



//HTML content for playersettings
function lbg_vp3_html5_player_settings_page()
{
	global $wpdb;
	global $lbg_vp3_html5_messages;
	global $lbg_vp3_html5_path;

	if (isset($_GET['id']) && isset($_GET['name'])) {
		$_SESSION['xid']=$_GET['id'];
		$_SESSION['xname']=$_GET['name'];
	}

	if(array_key_exists('Submit', $_POST) && $_POST['Submit'] == 'Update Player Settings') {
		$_GET['xmlf']='';
		$except_arr=array('Submit','name','pll_ajax_backend','pll_ajax_backend','page_scroll_to_id_instances');
			$wpdb->update(
				$wpdb->prefix .'lbg_vp3_html5_players',
				array(
				'name' => sanitize_text_field($_POST['name'])
				),
				array( 'id' => $_SESSION['xid'] )
			);

			$_SESSION['xname']=stripslashes($_POST['name']);


			foreach ($_POST as $key=>$val){
				if (in_array($key,$except_arr)) {
					unset($_POST[$key]);
				}
			}

			$wpdb->update(
				$wpdb->prefix .'lbg_vp3_html5_settings',
				$_POST,
				array( 'id' => $_SESSION['xid'] )
			);
			?>
			<div id="message" class="updated"><p><?php echo esc_html($lbg_vp3_html5_messages['data_saved']);?></p></div>
	<?php
	}

	$safe_sql=$wpdb->prepare( "SELECT * FROM (".$wpdb->prefix ."lbg_vp3_html5_settings) WHERE id = %d",$_SESSION['xid'] );
	$row = $wpdb->get_row($safe_sql,ARRAY_A);
	$row=lbg_vp3_html5_unstrip_array($row);
	$_POST = $row;
	$_POST=lbg_vp3_html5_unstrip_array($_POST);

	//categories
	$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_vp3_html5_categories) ORDER BY categ";
	$result = $wpdb->get_results($safe_sql,ARRAY_A);
	include_once($lbg_vp3_html5_path . 'tpl/settings_form.php');

}


function lbg_vp3_html5_player_playlist_page()
{
	global $wpdb;
	global $lbg_vp3_html5_messages;
	global $lbg_vp3_html5_path;

	if (isset($_GET['id']) && isset($_GET['name'])) {
		$_SESSION['xid']=$_GET['id'];
		$_SESSION['xname']=$_GET['name'];
	}

	$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_vp3_html5_categories) ORDER BY categ";
	$result = $wpdb->get_results($safe_sql,ARRAY_A);

	if (array_key_exists('xmlf', $_GET) && $_GET['xmlf']=='add_playlist_record') {
		if(array_key_exists('Submit', $_POST) && $_POST['Submit'] == 'Add Record') {
			$errors_arr=array();

			if (count($errors_arr)) {
				include_once($lbg_vp3_html5_path . 'tpl/add_playlist_record.php'); ?>
				<div id="error" class="error"><p><?php echo implode("<br>", $errors_arr);?></p></div>
	  <?php } else { // all requested fields are filled



		if (count($errors_arr)) {
			include_once($lbg_vp3_html5_path . 'tpl/add_playlist_record.php'); ?>
			<div id="error" class="error"><p><?php echo implode("<br>", $errors_arr);?></p></div>
	  	<?php } else { // no upload errors
				if (array_key_exists('category', $_POST)) {
						$all_categs=implode(";", $_POST['category']);
				}
				$max_ord = 1+$wpdb->get_var( $wpdb->prepare( "SELECT max(ord) FROM ". $wpdb->prefix ."lbg_vp3_html5_playlist WHERE playerid = %d",$_SESSION['xid'] ) );

				$wpdb->insert(
					$wpdb->prefix . "lbg_vp3_html5_playlist",
					array(
						'playerid' => sanitize_text_field($_POST['playerid']),
						'imgplaylist' => sanitize_text_field($_POST['imgplaylist']),
						'title' => sanitize_text_field($_POST['title']),
						'desc' => sanitize_text_field($_POST['desc']),
						'startpoint' => sanitize_text_field($_POST['startpoint']),
						'endpoint' => sanitize_text_field($_POST['endpoint']),
						'ord' => sanitize_text_field($max_ord)
					),
					array(
						'%d',
						'%s',
						'%s',
						'%s',
						'%s',
						'%s',
						'%d'
					)
				);

	  			if (isset($_POST['setitfirst'])) {
					$sql_arr=array();
					$ord_start=$max_ord;
					$ord_stop=1;
					$elem_id=$wpdb->insert_id;
					$ord_direction='+1';

					$sql_arr[]="UPDATE ".$wpdb->prefix."lbg_vp3_html5_playlist SET ord=ord+1  WHERE playerid = ".$_SESSION['xid']." and ord>=".$ord_stop." and ord<".$ord_start;
					$sql_arr[]="UPDATE ".$wpdb->prefix."lbg_vp3_html5_playlist SET ord=".$ord_stop." WHERE id=".$elem_id;

					foreach ($sql_arr as $sql)
						$wpdb->query($sql);
				}
				?>
					<div class="wrap">
						<div id="lbg_logo">
							<h2><?php esc_html_e('Playlist for player', 'vp3-html5' );?>: <span style="color:#FF0000; font-weight:bold;"><?php esc_html_e($_SESSION['xname']);?> - ID #<?php esc_html_e($_SESSION['xid']);?></span> - <?php esc_html_e('Add New', 'vp3-html5' );?></h2>
			 			</div>
						<div id="message" class="updated"><p><?php echo esc_html($lbg_vp3_html5_messages['data_saved']);?></p></div>
						<div>
							<p>&raquo; <a href="?page=LBG_VP3_HTML5_Playlist&xmlf=add_playlist_record"><?php esc_html_e('Add New', 'vp3-html5' );?></a></p>
							<p>&raquo; <a href="?page=LBG_VP3_HTML5_Playlist"><?php esc_html_e('Back to Playlist', 'vp3-html5' );?></a></p>
						</div>
					</div>
	  	<?php }
	  		}
		} else {
			include_once($lbg_vp3_html5_path . 'tpl/add_playlist_record.php');
		}

	} else {
		if (array_key_exists('duplicate_id', $_GET) && $_GET['duplicate_id']!='') {
						$max_ord = 1+$wpdb->get_var( $wpdb->prepare( "SELECT max(ord) FROM ". $wpdb->prefix ."lbg_vp3_html5_playlist WHERE playerid = %d",$_SESSION['xid'] ) );
						$safe_sql=$wpdb->prepare( "INSERT INTO ".$wpdb->prefix ."lbg_vp3_html5_playlist (  `playerid` ,`imgplaylist` ,`category` ,`title` ,`desc` ,`startpoint`,`endpoint` ,`ord`  )  SELECT  `playerid` ,`imgplaylist` ,`category` ,`title` ,`desc` ,`startpoint`,`endpoint` , ".$max_ord." FROM (".$wpdb->prefix ."lbg_vp3_html5_playlist) WHERE id = %d",$_GET['duplicate_id'] );
						$wpdb->query($safe_sql);

						echo "<script>location.href='?page=LBG_VP3_HTML5_Playlist&id=".$_SESSION['xid']."&name=".$_SESSION['xname']."'</script>";
		}

		$safe_sql=$wpdb->prepare( "SELECT * FROM (".$wpdb->prefix ."lbg_vp3_html5_playlist) WHERE playerid = %d ORDER BY ord",$_SESSION['xid'] );
		$result = $wpdb->get_results($safe_sql,ARRAY_A);

		$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_vp3_html5_categories) ORDER BY categ";
	    $result_categ = $wpdb->get_results($safe_sql,ARRAY_A);

		include_once($lbg_vp3_html5_path . 'tpl/playlist.php');
	}
}


//HTML duplicate player
function lbg_vp3_html5_duplicate_player_page()
{
	global $wpdb;
	global $lbg_vp3_html5_messages;
	global $lbg_vp3_html5_path;

	if (isset($_GET['id']) && isset($_GET['name'])) {
		$_SESSION['xid']=$_GET['id'];
		$_SESSION['xname']=$_GET['name'];
	}

	//insert player
	$wpdb->insert(
			$wpdb->prefix . "lbg_vp3_html5_players",
			array(
				'name' => sanitize_text_field('Duplicate of Player #'.$_SESSION['xid'])
			),
			array(
				'%s'
			)
		);

	//duplicate settings
	$safe_sql=$wpdb->prepare( "INSERT INTO ".$wpdb->prefix ."lbg_vp3_html5_settings (`youtubeVideoID`, `vimeoVideoID`, `mp4Url`, `mp4PreviewUrl`, `controlsColor`, `controlsColorHover`, `width`, `height`, `responsive`, `responsiveRelativeToBrowser`, `centerPlayer`, `skin`, `initialVolume`, `autoPlayFirstVideo`, `autoPlayOnMobile`, `loop`, `shuffle`, `firstVideo`, `showTopTitle`, `showTimer`, `showRewindBut`, `showPlayBut`, `showVolumeBut`, `showDownloadBut`, `showTwitterBut`, `showInfoBut`, `showFacebookBut`, `facebookAppID`, `facebookShareTitle`, `facebookShareDescription`, `showPlaylistBut`, `showFullscreenBut`, `showShuffleBut`, `showNextPrevBut`, `borderWidth`, `borderColor`, `playlistWidth`, `suggestedQuality`, `controlsBgFullScreenColor`, `playlistScrollerBgColorOFF`, `playlistScrollerBgColorON`, `numberOfThumbsPerScreen`, `showLogo`, `logoImagePath`, `logoLink`, `logoTarget`, `playlistRecordShowImg`, `playlistRecordShowTitle`, `playlistRecordShowDesc`, `playlistRecordHeight`, `playlistRecordPadding`, `playlistTitleFontSize`, `playlistTitleLineHeight`, `playlistDescFontSize`, `playlistDescLineHeight`, `playlistRecordBgOffColor`, `playlistRecordTitleOffColor`, `playlistRecordDescOffColor`, `playlistRecordBgOffImgOpacity`, `playlistRecordBgOnColor`, `playlistRecordTitleOnColor`, `playlistRecordDescOnColor`, `playlistRecordBgOnImgOpacity`, `playlistBgColor`, `playlistRecordTitleLimit`, `playlistRecordDescLimit`, `showPlaylistOnInit`, `categoryRecordBgOffColor`, `categoryRecordBgOnColor`, `categoryRecordBottomBorderOffColor`, `categoryRecordBottomBorderOnColor`, `categoryRecordTextOffColor`, `categoryRecordTextOnColor`, `showCategs`, `firstCateg`, `selectedCategBg`, `selectedCategOffColor`, `selectedCategOnColor`, `showSearch`, `searchAreaBg`, `searchInputText`, `searchInputBg`, `searchInputBorderColor`, `searchInputTextColor`, `topTitleColor`, `timerColor`, `bufferEmptyColor`, `bufferFullColor`, `seekbarColor`, `volumeOffColor`, `volumeOnColor`, `playButColorOff`, `playButColorOn`, `googleTrakingOn`, `googleTrakingCode`, `getYouTubeData`, `origThumbImgW`, `origThumbImgH` ) SELECT `youtubeVideoID`, `vimeoVideoID`, `mp4Url`, `mp4PreviewUrl`, `controlsColor`, `controlsColorHover`, `width`, `height`, `responsive`, `responsiveRelativeToBrowser`, `centerPlayer`, `skin`, `initialVolume`, `autoPlayFirstVideo`, `autoPlayOnMobile`, `loop`, `shuffle`, `firstVideo`, `showTopTitle`, `showTimer`, `showRewindBut`, `showPlayBut`, `showVolumeBut`, `showDownloadBut`, `showTwitterBut`, `showInfoBut`, `showFacebookBut`, `facebookAppID`, `facebookShareTitle`, `facebookShareDescription`, `showPlaylistBut`, `showFullscreenBut`, `showShuffleBut`, `showNextPrevBut`, `borderWidth`, `borderColor`, `playlistWidth`, `suggestedQuality`, `controlsBgFullScreenColor`, `playlistScrollerBgColorOFF`, `playlistScrollerBgColorON`, `numberOfThumbsPerScreen`, `showLogo`, `logoImagePath`, `logoLink`, `logoTarget`, `playlistRecordShowImg`, `playlistRecordShowTitle`, `playlistRecordShowDesc`, `playlistRecordHeight`, `playlistRecordPadding`, `playlistTitleFontSize`, `playlistTitleLineHeight`, `playlistDescFontSize`, `playlistDescLineHeight`, `playlistRecordBgOffColor`, `playlistRecordTitleOffColor`, `playlistRecordDescOffColor`, `playlistRecordBgOffImgOpacity`, `playlistRecordBgOnColor`, `playlistRecordTitleOnColor`, `playlistRecordDescOnColor`, `playlistRecordBgOnImgOpacity`, `playlistBgColor`, `playlistRecordTitleLimit`, `playlistRecordDescLimit`, `showPlaylistOnInit`, `categoryRecordBgOffColor`, `categoryRecordBgOnColor`, `categoryRecordBottomBorderOffColor`, `categoryRecordBottomBorderOnColor`, `categoryRecordTextOffColor`, `categoryRecordTextOnColor`, `showCategs`, `firstCateg`, `selectedCategBg`, `selectedCategOffColor`, `selectedCategOnColor`, `showSearch`, `searchAreaBg`, `searchInputText`, `searchInputBg`, `searchInputBorderColor`, `searchInputTextColor`, `topTitleColor`, `timerColor`, `bufferEmptyColor`, `bufferFullColor`, `seekbarColor`, `volumeOffColor`, `volumeOnColor`, `playButColorOff`, `playButColorOn`, `googleTrakingOn`, `googleTrakingCode`, `getYouTubeData`, `origThumbImgW`, `origThumbImgH` FROM (".$wpdb->prefix ."lbg_vp3_html5_settings) WHERE id = %d",$_SESSION['xid'] );
	$wpdb->query($safe_sql);
	$lastid = $wpdb->insert_id;


	//duplicateplaylist
	$safe_sql=$wpdb->prepare( "SELECT * FROM (".$wpdb->prefix ."lbg_vp3_html5_playlist) WHERE playerid = %d",$_SESSION['xid'] );
	$result = $wpdb->get_results($safe_sql,ARRAY_A);
	foreach ( $result as $row_playlist ) {
		$row_playlist=lbg_vp3_html5_unstrip_array($row_playlist);

		$safe_sql=$wpdb->prepare( "INSERT INTO ".$wpdb->prefix ."lbg_vp3_html5_playlist (  `playerid` ,`imgplaylist` ,`category` ,`title` ,`desc` ,`startpoint`,`endpoint` ,`ord`  ) SELECT $lastid ,`imgplaylist` ,`category` ,`title` ,`desc` ,`startpoint`,`endpoint` ,`ord` FROM (".$wpdb->prefix ."lbg_vp3_html5_playlist) WHERE id = %d",$row_playlist['id'] );
		$wpdb->query($safe_sql);
	}
	?>
	<div id="message" class="updated"><p><?php echo esc_html($lbg_vp3_html5_messages['duplicate_complete']);?></p></div>
	<?php

	$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_vp3_html5_players) ORDER BY id";
	$result = $wpdb->get_results($safe_sql,ARRAY_A);
	include_once($lbg_vp3_html5_path . 'tpl/players.php');


}


function lbg_vp3_html5_player_help_page()
{
	global $lbg_vp3_html5_path;
	include_once($lbg_vp3_html5_path . 'tpl/help.php');
}


function lbg_vp3_html5_generate_preview_code($sliderID,$videosInitialOrd) {
	global $wpdb;

	$safe_sql=$wpdb->prepare( "SELECT * FROM (".$wpdb->prefix ."lbg_vp3_html5_settings) WHERE id = %d",$sliderID );
	$row = $wpdb->get_row($safe_sql,ARRAY_A);
	$row=lbg_vp3_html5_unstrip_array($row);

	$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_vp3_html5_categories) ORDER BY categ";
	$result_categ = $wpdb->get_results($safe_sql,ARRAY_A);

	$path_to_plugin = plugin_dir_url( __FILE__ );

	//first categ
	$first_categ='';
	foreach ( $result_categ as $row_categ ) {
			if ( $row['firstCateg']==$row_categ['id']) {
				$first_categ=stripslashes($row_categ['categ']);
			}
	}

	//download
	$pathToDownloadFile_aux=$path_to_plugin.'lbg_vp3_html5/';

	$safe_sql=$wpdb->prepare( "SELECT * FROM (".$wpdb->prefix ."lbg_vp3_html5_playlist) WHERE playerid = %d ORDER BY ord",$sliderID );
	$result = $wpdb->get_results($safe_sql,ARRAY_A);


	$playlist_str='';
	$firstRecord='';
	$videosInitialOrd_arr = explode(',', $videosInitialOrd);
	$firstVideoAux_arr=array();
	foreach ( $result as $row_playlist ) {

		$row_playlist=lbg_vp3_html5_unstrip_array($row_playlist);
		$categ_arr=array();


		foreach ( $result_categ as $row_categ ) {
			if (preg_match_all('/\b'.$row_categ["id"].'\b/', stripslashes($row_playlist['category']), $matches)) {
				$categ_arr[]=stripslashes($row_categ['categ']);
			}
		}

		if (in_array($row_playlist['ord'], $videosInitialOrd_arr)) {
			$firstVideoAux_arr[$row_playlist['ord']]='<li data-bottom-thumb="'.$row_playlist["imgplaylist"].'"
							data-title="'.$row_playlist["title"].'"
							data-desc="'.$row_playlist["desc"].'"
							data-startpoint="'.$row_playlist["startpoint"].'"
							data-endpoint="'.$row_playlist["endpoint"].'">
					   </li>';
		} else {
			$playlist_str.='<li data-bottom-thumb="'.$row_playlist["imgplaylist"].'"
							data-title="'.$row_playlist["title"].'"
							data-desc="'.$row_playlist["desc"].'"
							data-startpoint="'.$row_playlist["startpoint"].'"
							data-endpoint="'.$row_playlist["endpoint"].'">
					   </li>';
		}
	}
	if ($videosInitialOrd!=-1) {
		$playlist_str='';
	}

	if (count($firstVideoAux_arr) > 0) {
			foreach ( $videosInitialOrd_arr as $term ) {
				$firstRecord.=$firstVideoAux_arr[$term];
			}
	}


	$new_div_start='';
	$new_div_end='';

	$content='<script>
		jQuery(function() {
					jQuery("#lbg_vp3_html5_'.$row["id"].'").lbg_vp3_html5({
						width:'.$row["width"].',
						height:'.$row["height"].',
						youtubeVideoID:"'.$row["youtubeVideoID"].'",
						vimeoVideoID:"'.$row["vimeoVideoID"].'",
						mp4Url:"'.$row["mp4Url"].'",
						mp4PreviewUrl:"'.$row["mp4PreviewUrl"].'",
						controlsColor:"#'.$row["controlsColor"].'",
						controlsColorHover:"#'.$row["controlsColorHover"].'",
						responsive:'.$row["responsive"].',
						responsiveRelativeToBrowser:'.$row["responsiveRelativeToBrowser"].',
						centerPlayer:'.$row["centerPlayer"].',
						shuffle:'.$row["shuffle"].',
						firstVideo:'.$row["firstVideo"].',
						initialVolume:'.$row["initialVolume"].',
						loop:'.$row["loop"].',
						showCategs:'.$row["showCategs"].',
						showSearch:'.$row["showSearch"].',
						showTopTitle:'.$row["showTopTitle"].',
						showTimer:'.$row["showTimer"].',
						showRewindBut:'.$row["showRewindBut"].',
						showPlayBut:'.$row["showPlayBut"].',
						showVolumeBut:'.$row["showVolumeBut"].',
						showFacebookBut:'.$row["showFacebookBut"].',
						facebookAppID:"'.$row["facebookAppID"].'",
						facebookShareTitle:"'.$row["facebookShareTitle"].'",
						facebookShareDescription:"'.$row["facebookShareDescription"].'",
						showTwitterBut:'.$row["showTwitterBut"].',
						showInfoBut:'.$row["showInfoBut"].',
						showDownloadBut:'.$row["showDownloadBut"].',
						showPlaylistBut:'.$row["showPlaylistBut"].',
						showFullscreenBut:'.$row["showFullscreenBut"].',
						showShuffleBut:'.$row["showShuffleBut"].',
						showNextPrevBut:'.$row["showNextPrevBut"].',
						borderColor:"#'.$row["borderColor"].'",
						playlistWidth:'.$row["playlistWidth"].',
						pathToDownloadFile:"'.$pathToDownloadFile_aux.'",
						absUrl:"'.plugins_url("", __FILE__).'/lbg_vp3_html5/",
						suggestedQuality:"'.$row["suggestedQuality"].'",
						controlsBgFullScreenColor:"#'.$row["controlsBgFullScreenColor"].'",
						playlistScrollerBgColorOFF:"#'.$row["playlistScrollerBgColorOFF"].'",
						playlistScrollerBgColorON:"#'.$row["playlistScrollerBgColorON"].'",
						numberOfThumbsPerScreen:'.$row["numberOfThumbsPerScreen"].',
						logoImagePath:"'.$row["logoImagePath"].'",
						logoLink:"'.$row["logoLink"].'",
						logoTarget:"'.$row["logoTarget"].'",
						showLogo:'.$row["showLogo"].',
						autoPlayFirstVideo:'.$row["autoPlayFirstVideo"].',
						autoPlayOnMobile:'.$row["autoPlayOnMobile"].',
						playlistRecordShowImg:'.$row["playlistRecordShowImg"].',
						playlistRecordShowTitle:'.$row["playlistRecordShowTitle"].',
						playlistRecordShowDesc:'.$row["playlistRecordShowDesc"].',
						playlistRecordHeight:'.$row["playlistRecordHeight"].',
						playlistRecordPadding:'.$row["playlistRecordPadding"].',
						playlistTitleFontSize:'.$row["playlistTitleFontSize"].',
						playlistTitleLineHeight:'.$row["playlistTitleLineHeight"].',
						playlistDescFontSize:'.$row["playlistDescFontSize"].',
						playlistDescLineHeight:'.$row["playlistDescLineHeight"].',
						playlistRecordBgOffColor:"'.((strpos($row["playlistRecordBgOffColor"],'://')===false)?'#':'').$row["playlistRecordBgOffColor"].'",
						playlistRecordTitleOffColor:"#'.$row["playlistRecordTitleOffColor"].'",
						playlistRecordDescOffColor:"#'.$row["playlistRecordDescOffColor"].'",
						playlistRecordBgOffImgOpacity:'.$row["playlistRecordBgOffImgOpacity"].',
						playlistRecordBgOnColor:"'.((strpos($row["playlistRecordBgOnColor"],'://')===false)?'#':'').$row["playlistRecordBgOnColor"].'",
						playlistRecordTitleOnColor:"#'.$row["playlistRecordTitleOnColor"].'",
						playlistRecordDescOnColor:"#'.$row["playlistRecordDescOnColor"].'",
						playlistRecordBgOnImgOpacity:'.$row["playlistRecordBgOnImgOpacity"].',
						playlistBgColor:"#'.$row["playlistBgColor"].'",
						playlistRecordTitleLimit:'.$row["playlistRecordTitleLimit"].',
						playlistRecordDescLimit:'.$row["playlistRecordDescLimit"].',
						showPlaylistOnInit:'.$row["showPlaylistOnInit"].',
						categoryRecordBgOffColor:"#'.$row["categoryRecordBgOffColor"].'",
						categoryRecordBgOnColor:"#'.$row["categoryRecordBgOnColor"].'",
						categoryRecordBottomBorderOffColor:"#'.$row["categoryRecordBottomBorderOffColor"].'",
						categoryRecordBottomBorderOnColor:"#'.$row["categoryRecordBottomBorderOnColor"].'",
						categoryRecordTextOffColor:"#'.$row["categoryRecordTextOffColor"].'",
						categoryRecordTextOnColor:"#'.$row["categoryRecordTextOnColor"].'",
						firstCateg:"'.$first_categ.'",
						selectedCategBg:"'.(($row["selectedCategBg"]=="transparent")?'':'#').$row["selectedCategBg"].'",
						selectedCategOffColor:"#'.$row["selectedCategOffColor"].'",
						selectedCategOnColor:"#'.$row["selectedCategOnColor"].'",
						searchAreaBg:"'.(($row["searchAreaBg"]=="transparent")?'':'#').$row["searchAreaBg"].'",
						searchInputText:"'.$row["searchInputText"].'",
						searchInputBg:"#'.$row["searchInputBg"].'",
						searchInputBorderColor:"#'.$row["searchInputBorderColor"].'",
						searchInputTextColor:"#'.$row["searchInputTextColor"].'",
						topTitleColor:"#'.$row["topTitleColor"].'",
						timerColor:"#'.$row["timerColor"].'",
						bufferEmptyColor:"#'.$row["bufferEmptyColor"].'",
						bufferFullColor:"#'.$row["bufferFullColor"].'",
						seekbarColor:"#'.$row["seekbarColor"].'",
						volumeOffColor:"#'.$row["volumeOffColor"].'",
						volumeOnColor:"#'.$row["volumeOnColor"].'",
						playButColorOff:"#'.$row["playButColorOff"].'",
						playButColorOn:"#'.$row["playButColorOn"].'",
						googleTrakingOn:'.$row["googleTrakingOn"].',
						googleTrakingCode:"'.$row["googleTrakingCode"].'",
						getYouTubeData:'.$row["getYouTubeData"].',
						pathToAjaxFiles:"'.plugins_url("", __FILE__).'/lbg_vp3_html5/",
						origThumbImgW:'.$row["origThumbImgW"].',
						origThumbImgH:'.$row["origThumbImgH"].'
					});
		});
	</script>
    <div id="lbg_vp3_html5_'.$row["id"].'" style="display:none;">
            <ul class="lbg_vp3_html5_list">'.$firstRecord.$playlist_str.'</ul>
    </div><br style="clear:both;">';

	return str_replace("\r\n", '', $content);
}

function lbg_vp3_html5_shortcode($atts, $content=null) {
	global $wpdb;

	shortcode_atts( array('settings_id'=>'', 'videos_initial_ord'=>''), $atts);
	if ($atts['settings_id']=='')
		$atts['settings_id']=1;
	if (!array_key_exists('videos_initial_ord', $atts))
		$atts['videos_initial_ord']=-1;


	return lbg_vp3_html5_generate_preview_code($atts['settings_id'],$atts['videos_initial_ord']);
}




register_activation_hook(__FILE__,"lbg_vp3_html5_activate"); //activate plugin and create the database
add_action('init', 'lbg_vp3_html5_init_sessions');	// initialize sessions
add_action('init', 'lbg_vp3_html5_load_styles');	// loads required styles
add_action('init', 'lbg_vp3_html5_load_scripts');			// loads required scripts
add_action('admin_menu', 'lbg_vp3_html5_plugin_menu'); // create menus
add_shortcode('lbg_vp3_html5', 'lbg_vp3_html5_shortcode');				// LBG VP3 HTML5 shortcode






/** OTHER FUNCTIONS **/

//stripslashes for an entire array
function lbg_vp3_html5_unstrip_array($array){
	if (is_array($array)) {
		foreach($array as &$val){
			if(is_array($val)){
				$val = unstrip_array($val);
			} else {
				$val = stripslashes($val);

			}
		}
	}
	return $array;
}





/* ajax update playlist record */

add_action('admin_head', 'lbg_vp3_html5_update_playlist_record_javascript');

function lbg_vp3_html5_update_playlist_record_javascript() {
	global $wpdb;
	//Set Your Nonce
	$lbg_vp3_html5_update_playlist_record_ajax_nonce = wp_create_nonce("lbg_vp3_html5_update_playlist_record-special-string");
	$lbg_vp3_html5_update_category_record_ajax_nonce = wp_create_nonce("lbg_vp3_html5_update_category_record-special-string");
	$lbg_vp3_html5_preview_record_ajax_nonce = wp_create_nonce("lbg_vp3_html5_preview_record-special-string");

	if(strpos($_SERVER['PHP_SELF'], 'wp-admin') !== false) {
			$page = (isset($_GET['page'])) ? $_GET['page'] : '';
			if(preg_match('/LBG_VP3_HTML5/i', $page)) {
?>



<script type="text/javascript" >
//delete the entire record
function lbg_vp3_html5_delete_entire_record (delete_id) {
	if (confirm('Are you sure?')) {
		jQuery("#lbg_vp3_html5_sortable").sortable('disable');
		jQuery("#"+delete_id).css("display","none");
		jQuery("#lbg_vp3_html5_updating_witness").css("display","block");
		var data = "action=lbg_vp3_html5_update_playlist_record&security=<?php echo esc_js($lbg_vp3_html5_update_playlist_record_ajax_nonce); ?>&updateType=lbg_vp3_html5_delete_entire_record&delete_id="+delete_id;
		// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
		jQuery.post(ajaxurl, data, function(response) {
			jQuery("#lbg_vp3_html5_sortable").sortable('enable');
			jQuery("#lbg_vp3_html5_updating_witness").css("display","none");
		});
	}
}

function updateCategory(theCategoryID,theCategory) {
	var data ="action=lbg_vp3_html5_update_category_record&security=<?php echo esc_js($lbg_vp3_html5_update_category_record_ajax_nonce); ?>&theCategoryID="+theCategoryID+"&theCategory="+theCategory;

	// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
	jQuery.post(ajaxurl, data, function(response) {
		//alert('Got this from the server: ' + response);
	});
}


function showDialogPreview(theSliderID) {  //load content and open dialog
	var data ="action=lbg_vp3_html5_preview_record&security=<?php echo esc_js($lbg_vp3_html5_preview_record_ajax_nonce); ?>&theSliderID="+theSliderID;

	// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
	jQuery.post(ajaxurl, data, function(response) {
		jQuery('#previewDialogIframe').attr('src','<?php echo plugins_url("tpl/preview.html?d=".time(), __FILE__)?>');
		jQuery("#previewDialog").dialog("open");
	});
}


jQuery(document).ready(function($) {
	/*PREVIEW DIALOG BOX*/
	jQuery( "#previewDialog" ).dialog({
	  minWidth:1200,
	  minHeight:500,
	  title:"Plugin Preview",
	  modal: true,
	  autoOpen:false,
	  hide: "fade",
	  resizable: false,
	  open: function() {
	  },
	  close: function() {
		jQuery('#previewDialogIframe').attr('src','');
	  }
	});

	if (jQuery('#lbg_vp3_html5_sortable').length) {
		jQuery( '#lbg_vp3_html5_sortable' ).sortable({
			placeholder: "ui-state-highlight",
			start: function(event, ui) {
	            ord_start = ui.item.prevAll().length + 1;
	        },
			update: function(event, ui) {
	        	jQuery("#lbg_vp3_html5_sortable").sortable('disable');
	        	jQuery("#lbg_vp3_html5_updating_witness").css("display","block");
				var ord_stop=ui.item.prevAll().length + 1;
				var elem_id=ui.item.attr("id");
				var data = "action=lbg_vp3_html5_update_playlist_record&security=<?php echo esc_js($lbg_vp3_html5_update_playlist_record_ajax_nonce); ?>&updateType=change_ord&ord_start="+ord_start+"&ord_stop="+ord_stop+"&elem_id="+elem_id;
				// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
				jQuery.post(ajaxurl, data, function(response) {
					jQuery("#lbg_vp3_html5_sortable").sortable('enable');
					jQuery("#lbg_vp3_html5_updating_witness").css("display","none");
					//alert('Got this from the server: ' + response);
				});
			}
		});
	}


	<?php
		$rows_count = $wpdb->get_var("SELECT COUNT(*) FROM ". $wpdb->prefix . "lbg_vp3_html5_playlist;");
		for ($i=1;$i<=$rows_count;$i++) {
	?>


				jQuery('#upload_imgplaylist_button_lbg_vp3_html5_<?php echo esc_js($i);?>').click(function(event) {
						var file_frame;
						event.preventDefault();
						// If the media frame already exists, reopen it.
						if ( file_frame ) {
							file_frame.open();
							return;
						}
						// Create the media frame.
						file_frame = wp.media.frames.file_frame = wp.media({
							title: jQuery( this ).data( 'uploader_title' ),
							button: {
							text: jQuery( this ).data( 'uploader_button_text' ),
							},
							multiple: false // Set to true to allow multiple files to be selected
						});
						// When an image is selected, run a callback.
						file_frame.on( 'select', function() {
							// We set multiple to false so only get one image from the uploader
							attachment = file_frame.state().get('selection').first().toJSON();
							// Do something with attachment.id and/or attachment.url here
							document.forms["form-playlist-lbg_vp3_html5_video-"+<?php echo esc_js($i);?>].imgplaylist.value=attachment.url;
							jQuery('#imgplaylist_'+<?php echo esc_js($i);?>).attr('src',attachment.url);
						});
						// Finally, open the modal
						file_frame.open();
				});






	jQuery("#form-playlist-lbg_vp3_html5_video-<?php echo esc_js($i);?>").submit(function(event) {

		/* stop form from submitting normally */
		event.preventDefault();

		//show loading image
		jQuery('#ajax-message-<?php echo esc_js($i);?>').html('<img src="<?php echo plugins_url('images/ajax-loader.gif', __FILE__)?>" />');

		var data ="action=lbg_vp3_html5_update_playlist_record&security=<?php echo esc_js($lbg_vp3_html5_update_playlist_record_ajax_nonce); ?>&"+jQuery("#form-playlist-lbg_vp3_html5_video-<?php echo esc_js($i);?>").serialize();

		// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
		jQuery.post(ajaxurl, data, function(response) {

			var mov_title = '';
			if (document.forms["form-playlist-lbg_vp3_html5_video-<?php echo esc_js($i);?>"].title.value!='')
				mov_title=document.forms["form-playlist-lbg_vp3_html5_video-<?php echo esc_js($i);?>"].title.value;

			var element_to_show = mov_title;


			jQuery('#mov_title_'+document.forms["form-playlist-lbg_vp3_html5_video-<?php echo esc_js($i);?>"].id.value).html(element_to_show);
			jQuery('#ajax-message-<?php echo esc_js($i);?>').html(response);
		});
	});
	<?php } ?>

});
</script>
<?php
		}
	}
}


add_action('wp_ajax_lbg_vp3_html5_update_playlist_record', 'lbg_vp3_html5_update_playlist_record_callback');

function lbg_vp3_html5_update_playlist_record_callback() {

	check_ajax_referer( 'lbg_vp3_html5_update_playlist_record-special-string', 'security' );
	global $wpdb;
	global $lbg_vp3_html5_messages;
	$errors_arr=array();

	//delete entire record
	if (array_key_exists('updateType', $_POST) && $_POST['updateType']=='lbg_vp3_html5_delete_entire_record') {
		$delete_id=$_POST['delete_id'];
		$safe_sql=$wpdb->prepare("SELECT * FROM ".$wpdb->prefix."lbg_vp3_html5_playlist WHERE id = %d",$delete_id);
		$row = $wpdb->get_row($safe_sql, ARRAY_A);
		$row=lbg_vp3_html5_unstrip_array($row);


		//delete the entire record
		$wpdb->query($wpdb->prepare("DELETE FROM ".$wpdb->prefix."lbg_vp3_html5_playlist WHERE id = %d",$delete_id));
		//update the oreder for the rest ord=ord-1 for > ord
		$wpdb->query($wpdb->prepare("UPDATE ".$wpdb->prefix."lbg_vp3_html5_playlist SET ord=ord-1 WHERE playerid = %d and  ord>".$row['ord'],$_SESSION['xid']));
	}

	//update elements order
	if (array_key_exists('updateType', $_POST) && $_POST['updateType']=='change_ord') {
		$sql_arr=array();
		$ord_start=$_POST['ord_start'];
		$ord_stop=$_POST['ord_stop'];
		$elem_id=(int)$_POST['elem_id'];
		$ord_direction='+1';
		if ($ord_start<$ord_stop)
			$sql_arr[]="UPDATE ".$wpdb->prefix."lbg_vp3_html5_playlist SET ord=ord-1  WHERE playerid = ".$_SESSION['xid']." and ord>".$ord_start." and ord<=".$ord_stop;
		else
			$sql_arr[]="UPDATE ".$wpdb->prefix."lbg_vp3_html5_playlist SET ord=ord+1  WHERE playerid = ".$_SESSION['xid']." and ord>=".$ord_stop." and ord<".$ord_start;
		$sql_arr[]="UPDATE ".$wpdb->prefix."lbg_vp3_html5_playlist SET ord=".$ord_stop." WHERE id=".$elem_id;

		foreach ($sql_arr as $sql)
			$wpdb->query($sql);
	}



	//submit update
	$theid=isset($_POST['id'])?$_POST['id']:0;
	if($theid>0 && !count($errors_arr)) {
		$except_arr=array('Submit'.$theid,'id','ord','action','security','updateType','pll_ajax_backend','page_scroll_to_id_instances');
		if (array_key_exists('category', $_POST)) {
				$_POST['category']=implode(";", $_POST['category']);
		}
		foreach ($_POST as $key=>$val){
			if (in_array($key,$except_arr)) {
				unset($_POST[$key]);
			}
		}

		$wpdb->update(
			$wpdb->prefix .'lbg_vp3_html5_playlist',
			$_POST,
			array( 'id' => $theid )
		);
		?>
			<div id="message" class="updated"><p><?php echo esc_html($lbg_vp3_html5_messages['data_saved']);?></p></div>
	<?php
	} else if (!isset($_POST['updateType'])) {
		$errors_arr[]=$lbg_vp3_html5_messages['invalid_request'];
	}

	if (count($errors_arr)) { ?>
		<div id="error" class="error"><p><?php echo implode("<br>", $errors_arr);?></p></div>
	<?php }

	wp_die(); // this is required to return a proper result
}


add_action('wp_ajax_lbg_vp3_html5_update_category_record', 'lbg_vp3_html5_update_category_record_callback');

function lbg_vp3_html5_update_category_record_callback() {
	check_ajax_referer( 'lbg_vp3_html5_update_category_record-special-string', 'security' );
	global $wpdb;

	if ($_POST['theCategory']!='') {
			$wpdb->update(
				$wpdb->prefix .'lbg_vp3_html5_categories',
				array(
				'categ' => sanitize_text_field($_POST['theCategory'])
				),
				array( 'id' => $_POST['theCategoryID'] )
			);
	}

	wp_die(); // this is required to return a proper result
}


add_action('wp_ajax_lbg_vp3_html5_preview_record', 'lbg_vp3_html5_preview_record_callback');

function lbg_vp3_html5_preview_record_callback() {
	check_ajax_referer( 'lbg_vp3_html5_preview_record-special-string', 'security' );
	global $wp_filesystem;
	if (empty($wp_filesystem)) {
    require_once (ABSPATH . '/wp-admin/includes/file.php');
    WP_Filesystem();
	}

	$aux_val='<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html>
					<head>
						<link href="'.plugins_url('lbg_vp3_html5/lbg_vp3_html5.css', __FILE__).'" rel="stylesheet" type="text/css">
						<link href="'.plugins_url('css/pt_sans.css', __FILE__).'" rel="stylesheet" type="text/css">

						<script src="'.plugins_url('js/jquery-1.11.0.js', __FILE__).'" type="text/javascript"></script>
						<script src="'.plugins_url('js/jquery-ui-1.10.4.js', __FILE__).'"></script>
						<script src="'.plugins_url('lbg_vp3_html5/js/jquery.mousewheel.min.js', __FILE__).'" type="text/javascript"></script>
						<script src="'.plugins_url('lbg_vp3_html5/js/jquery.touchSwipe.min.js', __FILE__).'" type="text/javascript"></script>
						<script src="'.plugins_url('lbg_vp3_html5/js/vimeo.player.js', __FILE__).'" type="text/javascript"></script>
						<script src="'.plugins_url('lbg_vp3_html5/js/26e31fe740.js', __FILE__).'" type="text/javascript"></script>
						<script src="'.plugins_url('lbg_vp3_html5/js/screenfull.min.js', __FILE__).'" type="text/javascript"></script>
						<script src="'.plugins_url('lbg_vp3_html5/js/lbg_vp3_html5.js', __FILE__).'" type="text/javascript"></script>

						<script src="'.plugins_url('lbg_vp3_html5/js/google_a.js', __FILE__).'" type="text/javascript"></script>

					</head>
					<body style="padding:0px;margin:0px;">';

	$aux_val.=lbg_vp3_html5_generate_preview_code($_POST['theSliderID'],-1);
	$aux_val.="</body>
				</html>";
	$filename=plugin_dir_path(__FILE__) . 'tpl/preview.html';
	if ( ! $wp_filesystem->put_contents(  $filename, $aux_val, FS_CHMOD_FILE) ) {
		echo "error saving file!";
	}

	wp_die(); // this is required to return a proper result
}


?>
